第一周:[LeetCode]1. Two Sum

来源:互联网 发布:中国国家顶级域名 编辑:程序博客网 时间:2024/05/18 01:15

[LeetCode]1. Two Sum

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,Because nums[0] + nums[1] = 2 + 7 = 9,return [0, 1].


方法一:暴力,时间复杂度是O(n2),超时
方法二:使用一个哈希表,将target-nums[i]的值存在nums[i]的下标下,每次迭代时寻找nums[i]是否已经在哈希表中,若在哈希表中,则输出答案,时间复杂度是O(n)

class Solution {public:    vector<int> twoSum(vector<int>& numbers, int target) {        unordered_map<int, int> m;        vector<int> result;        for(int i=0; i<numbers.size(); i++){            if (m.find(numbers[i])==m.end() ) {                 m[target - numbers[i]] = i;             }else {                 result.push_back(m[numbers[i]]);                result.push_back(i);                break;            }        }        return result;    }};
0 0